-- register with oe
library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

entity regoe is
generic ( tAC :time := 7 ns; tDQ :time := 2 ns);
    port (
		ck : in std_logic;
        input : in STD_LOGIC;
        output : out STD_LOGIC;
        not_en: in STD_LOGIC
    );
end regoe;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

architecture regoe_arch of regoe is
signal data : std_logic;
begin

proc_ck: process (ck,input,data)
begin
if (rising_edge(ck)) then
  data <= input after tDQ;
else
  data <= data;
end if;
end process proc_ck;

proc_en: process (not_en,data)
begin
if (not_en='0') then
  output <= data after tAC;
else
  output <= 'Z' after tAC;
end if;
end process proc_en;

end regoe_arch;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;


entity regoen is
generic ( size :integer := 32;  tAC :time := 7 ns; tDQ :time := 2 ns);
    port (
		ck : in std_logic;
        input : in STD_LOGIC_VECTOR (size-1 downto 0);
        output : out STD_LOGIC_VECTOR (size-1 downto 0);
        not_en: in STD_LOGIC
    );
end regoen;

library IEEE;
use IEEE.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;

architecture regoen_arch of regoen is
-- Component instantiated by Turbo autoplace on 11/20/95 at 11:49:16
COMPONENT regoe
generic ( tAC :time := 7 ns; tDQ :time := 2 ns);
    port (
		ck : in std_logic;
        input : in STD_LOGIC;
        output : out STD_LOGIC;
        not_en: in STD_LOGIC
    );
END COMPONENT;
begin

c_call: FOR i IN 0 TO size-1 GENERATE
          bits: regoe
          generic map (tAC => tAC, tDQ => tDQ) 
          port map (ck => ck, input => input(i), output => output(i), not_en => not_en);
        END GENERATE;    
end regoeN_arch;
